;*******************************************************************************
;PROGRAMME      : LectureLAI_2000
;AUTEUR         : F. MAIGNAN
;CREATION       : 03/10/2008
;COMPILATEUR    : IDL
;OBJECTIF       : Lecture fichiers MODIS Senegal
;*******************************************************************************
;+
; .. LectureLAI_2000_FM.pro
;
; ======================
; LectureLAI_2000_FM.pro
; ======================
;
; TODO
; ====
; 
; make it work
;
; split 
; 
; hard coded path
;
; EVOLUTIONS
; ==========
;
; $Id: LectureLAI_2000_FM.pro 335 2011-08-10 09:46:39Z pinsard $
;
; $URL$
;
; - fplod 20100826T132803Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * minimal rest header
;
;-
;*******************************************************************************
PRO LectureLAI_2000_FM, PLOT=plot


FORWARD_FUNCTION LectureLAI


;*** constantes
path='/home/orchidee01/cbobee/donnees_sat/modis/lai/'
file=path+'lai-2000/MOD15A2.A2000057.h16v07.005.2006269043641.hdf'
XDim=1200
YDim=1200
h=16
v=07
NB_LIG_MODIS = 21600
;latmin=14+45./60 & latmax=16+05./60
;lonmin=-17+30./60 & lonmax=-15+45./60 

latmin=14.63 & latmax=16.55
lonmin=-17.55 & lonmax=-15.70


;*** declarations
lat=MAKE_ARRAY(XDIM,YDIM,/FLOAT,VALUE=!VALUES.F_NAN)
lon=MAKE_ARRAY(XDIM,YDIM,/FLOAT,VALUE=!VALUES.F_NAN)


;*** initialisation environnement graphique
device,decomposed=0,retain=2
loadct,39
tvlct,r,g,b,/GET
!P.COLOR=0
!P.BACKGROUND=255


;*** version -> HDF4
id=HDF_OPEN(file)  
HDF_LIB_INFO, id, VERSION=VER  
PRINT, 'The file ', file,' was created with : ', VER  
HDF_CLOSE, id  


;*** lecture du LAI
LAI=LectureLAI(file)


;*** extraction
FOR ilig_MODIS=YDIM*v, YDIM*(v+1)-1 DO BEGIN				;*** attention, on compte lig/col a partir de 0
	lat[*,ilig_MODIS-YDIM*v] = 90.D - (ilig_MODIS + 0.5D)*180./NB_LIG_MODIS
	FOR jcol_MODIS=XDIM*h, XDIM*(h+1)-1 DO BEGIN
		Ni_MODIS = ROUND(NB_LIG_MODIS*cos(lat[jcol_MODIS-XDIM*h,ilig_MODIS-YDIM*v]*!DTOR))
		lon[jcol_MODIS-XDIM*h,ilig_MODIS-YDIM*v] = 180.D/Ni_MODIS*(jcol_MODIS - NB_LIG_MODIS + 0.5D)
	ENDFOR
ENDFOR
COND_LATLON=WHERE(lat GE latmin and lat LE latmax AND lon GE lonmin and lon LE lonmax,COMPLEMENT=COND_NOTOK)
zz=ARRAY_INDICES(lat,COND_LATLON)
indice_latmax=min(zz[1,*],max=indice_latmin)
indice_lonmin=min(zz[0,*],max=indice_lonmax)
lat_extract=lat[indice_lonmin:indice_lonmax,indice_latmax:indice_latmin]
lon_extract=lon[indice_lonmin:indice_lonmax,indice_latmax:indice_latmin]
lai[COND_NOTOK]=!VALUES.F_NAN
lai_extract=lai[indice_lonmin:indice_lonmax,indice_latmax:indice_latmin]
taille=size(lai_extract)


;*** affichage graphique
IF KEYWORD_SET(plot) THEN BEGIN
	window,2,xsize=taille[1],ysize=taille[2]
	tvscl,lai_extract,/NAN,/ORDER, xsize=taille[1],ysize=taille[2]
	;stop
ENDIF



;*** boucle de lecture des fichiers LAI
;files=FILE_SEARCH(path,'lai-200[0-4]/MOD15A2.A200????.h16v07.005.*.hdf',COUNT=nb_files)
files=FILE_SEARCH(path,'lai-2000/MOD15A2.A200????.h16v07.005.*.hdf',COUNT=nb_files)
lai_extract=MAKE_ARRAY(nb_files,indice_lonmax-indice_lonmin+1,indice_latmin-indice_latmax+1,/FLOAT,VALUE=!VALUES.F_NAN)

datenum=intarr(nb_files)

FOR ifile=0, nb_files-1 DO BEGIN
    print,ifile, files[ifile]
    
    nom_court=FILE_BASENAME(files[ifile])
	res=STRSPLIT(nom_court,'.',/EXTRACT)
    	date=strmid(res[1],5,3)
    	print, date
    	datenum(ifile)=fix(date)
	;stop

;    date=strmid(files[ifile],68,3)
;    print, date
;    datenum(ifile)=fix(date)

	lai=LectureLAI(files[ifile], PLOT=plot)
	lai[COND_NOTOK]=!VALUES.F_NAN
	lai_extract[ifile,*,*]=lai[indice_lonmin:indice_lonmax,indice_latmax:indice_latmin]

;*** affichage graphique
	IF KEYWORD_SET(plot) THEN BEGIN
		window,2,XSIZE=taille[1],YSIZE=taille[2],title=STRING(ifile)
		tvscl,lai_extract[ifile,*,*],/ORDER,/NAN
		wait,0.5
		;stop
	ENDIF
ENDFOR

IF KEYWORD_SET(plot) THEN BEGIN
	window,1
	FOR ilig=0, taille[2]-1 DO BEGIN
		FOR jcol=0, taille[2]-1 DO BEGIN
			IF FINITE(MAX(lai_extract[*,jcol,ilig],/NAN)) THEN BEGIN
				plot, datenum,lai_extract[*,jcol,ilig]
				wait,0.5
			ENDIF
		ENDFOR
	ENDFOR
ENDIF


;*** enregistrement ascii
file='/home/orchidee01/cbobee/donnees_sat/modis/lai/lai-2000/lai2000_float.txt'

OPENW,lun,file,/GET_LUN, ERROR = error
IF (error NE 0) then begin
   ras = report(['eee : can not open for writing '$
         + '!C' $
         + file])
   STOP
ENDIF

printf,lun,datenum
FOR ilig=0,taille[2]-1 DO BEGIN
	FOR jcol=0, taille[1]-1 DO BEGIN
		printf,lun,lat_extract[jcol,ilig],lon_extract[jcol,ilig],lai_extract[*,jcol,ilig]
	ENDFOR
ENDFOR
CLOSE,lun
FREE_LUN,lun

STOP

;OPENW,lun,file,/GET_LUN
;printf,lun,datenum
;printf,lun,lai_extract
;CLOSE,lun
;FREE_LUN,lun

STOP

END

FUNCTION LectureLAI, file, PLOT=plot

sd_id=HDF_OPEN(file,/read)
IF sd_id EQ -1 THEN BEGIN
	ALB=MAKE_ARRAY(1200,1200,/FLOAT,VALUE=!VALUES.F_NAN)
	print, 'bad file :',file
ENDIF ELSE BEGIN
	sd_id=HDF_SD_START(file,/read)
	sds_id=HDF_SD_SELECT(sd_id,1)
	HDF_SD_GETDATA,sds_id,LAI 
	HDF_SD_GETINFO,sds_id,DIMS=dims,NAME=name,NDIMS=ndims,TYPE=type,UNIT=unit
	print,'name=',name
	id_valid_range=HDF_SD_ATTRFIND(sds_id,'valid_range')
	HDF_SD_ATTRINFO,sds_id,id_valid_range,data=valid_range
	id_scale_factor=HDF_SD_ATTRFIND(sds_id,'scale_factor')
	HDF_SD_ATTRINFO,sds_id,id_scale_factor,data=scale_factor
	id_fill_value=HDF_SD_ATTRFIND(sds_id,'_FillValue')
	HDF_SD_ATTRINFO,sds_id,id_fill_value,data=fill_value
	HDF_SD_ENDACCESS, sds_id
;*** Fermeture du fichier HDF
	HDF_SD_END, sd_id

;*** decodage
	LAI=FLOAT(LAI)
	COND_NAN=WHERE(LAI EQ fill_value[0] OR LAI LT valid_range[0] OR LAI GT valid_range[1])
	IF COND_NAN[0] NE -1 THEN LAI[COND_NAN]=!VALUES.F_NAN
	;stop
	LAI=LAI*scale_factor[0]
	;stop
ENDELSE

;*** affichage graphique
IF KEYWORD_SET(plot) THEN BEGIN 
	window,0,xsize=600,ysize=600
	tvscl,REBIN(LAI,600,600),/NAN,/ORDER
	stop
ENDIF
;sd_id=HDF_SD_START(file,/read)
;sds_id=HDF_SD_SELECT(sd_id,1)
;HDF_SD_GETDATA,sds_id,LAI 
;HDF_SD_GETINFO,sds_id,DIMS=dims,NAME=name,NDIMS=ndims,TYPE=type,UNIT=unit
;;print,'name=',name
;id_valid_range=HDF_SD_ATTRFIND(sds_id,'valid_range')
;HDF_SD_ATTRINFO,sds_id,id_valid_range,data=valid_range
;id_scale_factor=HDF_SD_ATTRFIND(sds_id,'scale_factor')
;HDF_SD_ATTRINFO,sds_id,id_scale_factor,data=scale_factor
;id_fill_value=HDF_SD_ATTRFIND(sds_id,'_FillValue')
;HDF_SD_ATTRINFO,sds_id,id_fill_value,data=fill_value
;HDF_SD_ENDACCESS, sds_id
;;*** Fermeture du fichier HDF
;HDF_SD_END, sd_id

;*** decodage
;LAI=FLOAT(LAI)
;COND_NAN=WHERE(LAI EQ fill_value[0] OR LAI LT valid_range[0] OR LAI GT valid_range[1])
;IF COND_NAN[0] NE -1 THEN LAI[COND_NAN]=!VALUES.F_NAN
;stop
;LAI=LAI*scale_factor[0]

;*** affichage graphique
;IF KEYWORD_SET(plot) THEN BEGIN 
	;window,0,xsize=600,ysize=600
	;tvscl,REBIN(LAI,600,600),/NAN,/ORDER
	;stop
;ENDIF

RETURN,LAI

END
