; docformat = 'rst'
;+
; .. _cloud_month.pro:
;
; ===============
; cloud_month.pro
; ===============
;
; DESCRIPTION
; ===========
;
; Programme d'analyse des nuages avec MSG  - version LE sur skylla
; identification des zones les plus convectives par jour, puis trace du
; homuller sur le mois
; j'ai mis en Nan les valeurs de Tbmsg hors nuages (3 cumulés
; min sur le jour)
;
; SEE ALSO
; ========
;
; :ref:`guide data MSG <data_msg>`
;
; TODO
; ====
;
; ::
;
;  name='msg-tb108_2006-08-01_15min.nc'
;  path='/Users/lelod/dossiers/progX11/varamma_id/nuages/'
;  path="/net/zeus/usr/zeus/incas/mousson/MSG"  ; pour travail sur zeus
;
; missing listmsg
;
; EVOLUTIONS
; ==========
;
; $Id: cloud_month.pro 335 2011-08-10 09:46:39Z pinsard $
;
; $URL$
;
; - fplod 20110422T161959Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * prepare usage of PROJECT
;
; - fplod 20100810T145755Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * minimal rst header
;
;-
pro cloud_month,threshold,nbcloudmin

@cm_project

name=''
nbjour=31
threshold=260.    ; seuil de Tb canal 10.8
nbcloudmin=3      ; valeur du seuil de duree
seuil=strcompress(string(threshold),/remove_all)
filemsg=project_id_env+'listmsg'
openr,1,filemsg, ERROR = error
IF (error NE 0) then begin
   ras = report(['eee : can not open for reading '$
         + '!C' $
         + 'code : ' + !ERROR_STATE.MSG $
         + filemsg])
   STOP
ENDIF

ijour=0
while not(eof(1)) do begin
;for ijour=0,nbjour-1 do begin
   readf,1,name
   print,name
      ;name='msg-tb108_2006-08-13_15min.nc'
      ;name='msg-tb108_2006-07-07_15min.nc'
   file=path+name
   initncdf, file, xaxisname = 'longitude', yaxisname = 'latitude'
   lon1=-10 & lon2=-6 & lat1=0 & lat2=8
   h1=0 & h2=93
   domdef,lon1,lon2,lat1,lat2
   data=read_ncdf('DATA',h1,h2,/timestep,timevar = 'time', file = file)
   date=strmid(name,50,50)
   ;pltt,window=0,data.arr,'yt'
   s=size(data.arr,/DIMENSIONS)
   ni=s[0]
   ll=s[1]
   nbt=s[2]
   print,ni,ll,nbt
   ;initialisation des fichiers finaux
   if(ijour eq 0) then tbday=fltarr(ni,ll,nbjour)
   if(ijour eq 0) then kontday=intarr(ni,ll,nbjour)
   ;boucle sur les quarts d'heure
   compt=intarr(ni,ll,nbt)          ;initialisation pour calcul des cumuls journaliers
   tbmoy=fltarr(ni,ll,nbt)
   for itime=0,nbt-1 do begin
      tbmsg=smooth(data.arr(*,*,itime),10,/edge_truncate,/nan)
      bon=where(tbmsg gt 100 and tbmsg le 320,nbon)
      if (nbon ne 0) then begin
         clear=where(tbmsg gt threshold)
         tbmsg(clear)=0
         ;extraction des nuages
         ;utilisation de la fonction idl qui fait le travail toute seule!
         tb=fltarr(ni,ll)
         cloud=tbmsg
         indnu=where(tbmsg gt 0,nbdetect)
         if (nbdetect ne 0) then cloud(indnu)=1
         nuag=label_region(cloud)
         numax=max(nuag)
         if(numax ne 0) then begin
            ; calcul par nuage identifie:
                   for inu=1,numax do begin
                      zonu=where(nuag eq inu)
                      tb(zonu)=mean(tbmsg(zonu),/nan)
                      ;print,mean(tb(zonu))
                   endfor
         endif
         tbmoy(*,*,itime)=tb
         compt(*,*,itime)=nuag
      endif
   endfor
  ;Moyennes et ecarts types pour la journee: on ne considere que les
                                ;nuages qui sont vus plus d'un
                                ;certain temps (nbcloudmin)
                                ;donc elimination des nuages de courte duree
   nuday=where(compt ne 0,nbnuday)
 if (nbnuday ne 0) then begin
      compt(nuday)=1
      cloud3d=label_region(compt) ; ca marche en 3d!
   for j=0,ll-1 do begin
      for i=0,ni-1 do begin
         coco=cloud3d(i,j,*)
         toto=tbmoy(i,j,*)
         indcloud=where(coco ne 0,nbcloud)
         if (nbcloud gt 0) then begin
          nuax=max(coco) & nuin=min(coco(indcloud))
           totonu=fltarr(nuax-nuin+1)
            coconu=intarr(nuax-nuin+1)
            for nu=nuin,nuax do begin
               testnu=where(coco eq nu,ok)
               if( ok ge nbcloudmin) then begin           ;on a un nuage
                  totonu(nu-nuin)=total(toto(testnu))     ;somme des valeurs du nuage
                  coconu(nu-nuin)=ok                      ;nb de pas de temps pour le nuage
               endif
            endfor
            tbtot=total(totonu)
            cotot=total(coconu)
            if(cotot ne 0) then tbday(i,j,ijour)=tbtot/cotot
               kontday(i,j,ijour)=cotot
               ;if(cotot-nbcloud ne 0) then print, 'ya des petits nuages',cotot,nbcloud
            endif
      endfor
   endfor
 endif
   ; window,1,xsize=300,ysize=500
   ; plt,window=1,tbday(*,*,ijour),/realcont,/cont_nofill,title='tb moy MSG',min=100,/rempli,/nocontour,/noerase
   ; window,2,xsize=300,ysize=500
   ; plt,window=2,kontday(*,*,ijour),/realcont,/cont_nofill,title='nb nuages MSG',/rempli,/nocontour,min=0,/noerase
ijour=ijour+1
endwhile
;endfor
h1=0 & h2=nbjour-1
data=read_ncdf('DATA',h1,h2,/timestep,timevar = 'time', file = file)
time=julday(07,1,2006)+lindgen(nbjour)
zonuage=where(kontday ne 0,nbc,complement=zoclear)
kontday(zonuage)=kontday(zonuage)
tbday(zoclear)=threshold+10 ;!values.F_Nan
kontday(zoclear)=-10
pltt,window=0,tbday,'yt',title='latitude - time MSG cloud Tb - threshold'+seuil,/nocontour,/rempli,min=min(tbday,/nan)
pltt,window=1,kontday,'yt',title='latitude - time MSG cloud number - threshold'+seuil,/nocontour,/rempli,max=20,min=0
close,1
end
