; docformat = 'rst'
;+
;
; .. _figure14.pro:
;
; ============
; figure14.pro
; ============
;
; plot figure 14 of paper1
;
; :Categories: figure
;
; :Uses:
;  :ref:`hovmuller.pro`
;  :ref:`forout.pro`
;
; :Restrictions:
;  - Requires SAXO
;
; :Pre:
;  :ref:`varamma_profile.sh`
;
;  for AMSU dataset be sure to have :file:`{c}{x}.an{yyyy}_climato.nc`
;  in the directory defined in :file:`${PROJECT_ID}/`
;
;
; :Post:
;  :ref:`varamma_profile.sh`
;
; :Todo:
;
; :Examples:
;
; To produce a PNG file :
;
; ::
;
;    figure14
;
; :History:
;
;  $Id: figure14.pro 215 2011-04-26 10:33:10Z pinsard $
;
; - fplod 2009-05-14T15:38:53Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * taking into account :ref:`hovmuller.pro` new timebox keyword
;
; - fplod 2008-12-23T15:47:59Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * add ubox keywords required by hovmuller.pro
;
; - fplod 2008-08-14T15:24:42Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * more concrete action ...
;
; - fplod 2008-08-11T16:10:05Z aedon.locean-ipsl.upmc.fr (Darwin)
;
;   * creation of header not yet ok, just the idea
;
;-
pro figure14, _EXTRA=extra
;
compile_opt idl2, strictarrsubs
;
ifigure=14
;
fullfilename_out=forout('figure' + string(ifigure,format='(I2.2)')+ '.png', _EXTRA=extra)
IF (fullfilename_out EQ -1) THEN BEGIN
 RETURN
ENDIF
;
hovmuller, 'AMSU', 'a4', timebox=[00000401L,00001031L], DATASETTYPE='varamma_t3', AXE='latitude', ubox=[-30.,+40.,-30.,45.], int = 1.5, small=[2,2,1],/nocolorbar, /nosave
hovmuller, 'AMSU', 'a5', timebox=[00000401L,00001031L], DATASETTYPE='varamma_t3', AXE='latitude', ubox=[-30.,+40.,-30.,45.], int = 1. , small=[2,2,2],/nocolorbar, /nosave,/noerase
hovmuller, 'AMSU', 'b5', timebox=[00000401L,00001031L], DATASETTYPE='varamma_t3', AXE='latitude', ubox=[-30.,+40.,-30.,45.], int = 1.5, small=[2,2,3],/nosave,/noerase
hovmuller, 'AMSU', 'b3', timebox=[00000401L,00001031L], DATASETTYPE='varamma_t3', AXE='latitude', ubox=[-30.,+40.,-30.,45.], int = 2. ,small=[2,2,4],/nosave,/noerase
;
saveimage, fullfilename_out,/png
;
end
