function y = meanNaN(x,dim)
%
%+
%
% =========
% meanNaN.m
% =========
%
% .. function:: meanNaN(x,dim)
%
% DESCRIPTION
% ===========
%
% Y=MEANnAn(X,n)
%
% Donne la moyenne arithmetique d'un vecteur ou matrice
% Contenant de NaN's.
%
% Fonctionne comme MEAN, sauf que:
%
%  - Renvoie NaN, lorsqu'il n'y a que des NaN;
%  - Renvoie la moyenne des elements non NaN's;%'
%
% EVOLUTIONS
% ==========
%
% $Id$
%
% - fplod 20110705T125628Z cratos.locean-ipsl.upmc.fr (Linux)
%
%   * minimal header
%
% - FVI revise pour Matlab5  19-sept-97
%
% - FVi 2-May-95
%
%-

if prod(size(x))==1, y = x; return, end

if nargin==1, 
  dim = min(find(size(x)~=1));
  if isempty(dim), dim = 1; end
end

if ~isempty(x),
n=~isnan(x);
ii=find(~n);
x(ii)=zeros(size(ii));
N=sum(n,dim);
i=find(~N);
N(i)=NaN*ones(size(i));
y = sum(x,dim)./N;
else
  %y = NaN;
y=[];
end
